unit Asgunit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, AdvGrid, StdCtrls, Buttons, ExtCtrls,
  Menus, ClipBrd, asprev, asabout, asfind, ComCtrls, mswheel;

type
  TDemo = class(TForm)
    FontDialog1: TFontDialog;
    MainMenu1: TMainMenu;
    Loaddata1: TMenuItem;
    Loadfromfile1: TMenuItem;
    Savetofile1: TMenuItem;
    SavetoHTML1: TMenuItem;
    SavetoCSV1: TMenuItem;
    SaveasXLS1: TMenuItem;
    Clipboard1: TMenuItem;
    Print1: TMenuItem;
    Copytoclipboard2: TMenuItem;
    Pastefromclipboard2: TMenuItem;
    Copyselectiontoclipboard1: TMenuItem;
    Print2: TMenuItem;
    Printpreview1: TMenuItem;
    Setselection1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Pastefromclipboard1: TMenuItem;
    LoadfromCSV1: TMenuItem;
    LoadfromXLS1: TMenuItem;
    Hide1: TMenuItem;
    Column11: TMenuItem;
    Column21: TMenuItem;
    Column31: TMenuItem;
    Column41: TMenuItem;
    Search1: TMenuItem;
    Findfirst1: TMenuItem;
    Findnext1: TMenuItem;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    AdvStringGrid2: TAdvStringGrid;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button8: TButton;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    Button6: TButton;
    RadioGroup1: TRadioGroup;
    fixedsort: TCheckBox;
    multiline: TCheckBox;
    colro: TCheckBox;
    AdvStringGrid1: TAdvStringGrid;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button3Click(Sender: TObject);
    procedure AdvStringGrid1GetFormat(Sender: TObject; ACol: Longint;
      var AStyle: TSortStyle);
    procedure AdvStringGrid1GetAlignment(Sender: TObject; ARow,
      ACol: Longint; var AAlignment: TAlignment);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure AdvStringGrid1GetCellColor(Sender: TObject; ARow,
      ACol: Longint; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure FormCreate(Sender: TObject);
    procedure AdvStringGrid1GridHint(Sender: TObject; Arow, Acol: Longint;
      var hintstr: string);
    procedure Button4Click(Sender: TObject);
    procedure Loadfromfile1Click(Sender: TObject);
    procedure Savetofile1Click(Sender: TObject);
    procedure SavetoHTML1Click(Sender: TObject);
    procedure SavetoCSV1Click(Sender: TObject);
    procedure AdvStringGrid1AutoInsertRow(Sender: TObject; ARow: Longint);
    procedure AdvStringGrid1AutoDeleteRow(Sender: TObject; aRow: Longint);
    procedure AdvStringGrid1ClickSort(Sender: TObject; aCol: Longint);
    procedure CopytoExcel1Click(Sender: TObject);
    procedure SaveasXLS1Click(Sender: TObject);
    procedure Copytoclipboard2Click(Sender: TObject);
    procedure Pastefromclipboard2Click(Sender: TObject);
    procedure Print2Click(Sender: TObject);
    procedure Printpreview1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Setselection1Click(Sender: TObject);
    procedure fixedsortClick(Sender: TObject);
    procedure Copyselectiontoclipboard1Click(Sender: TObject);
    procedure Pastefromclipboard1Click(Sender: TObject);
    procedure LoadfromCSV1Click(Sender: TObject);
    procedure LoadfromXLS1Click(Sender: TObject);
    procedure AdvStringGrid1PrintPage(Sender: TObject; Canvas: TCanvas;
      pagenr, pagexsize, pageysize: Integer);
    procedure Column11Click(Sender: TObject);
    procedure Findfirst1Click(Sender: TObject);
    procedure Findnext1Click(Sender: TObject);
    procedure multilineClick(Sender: TObject);
    procedure AdvStringGrid1CanEditCell(Sender: TObject; Arow,
      Acol: Integer; var canedit: Boolean);
    procedure AdvStringGrid1CellValidate(Sender: TObject; Col,
      Row: Integer; var Value: String; var Valid: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AdvStringGrid2GetAlignment(Sender: TObject; ARow,
      ACol: Integer; var AAlignment: TAlignment);
  private
     bitmap1,bitmap2,bitmap3,bitmap4,bitmap5:tbitmap;
     icon1,icon2,icon3,icon4,icon5:ticon;
     procedure InitGraphicGrid;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Demo: TDemo;

implementation

{$R *.DFM}
{$R iehand.res}
{$R icons.res}

procedure TDemo.Button3Click(Sender: TObject);
begin
advstringgrid1.autosize:=true;
end;

procedure TDemo.AdvStringGrid1GetFormat(Sender: TObject; ACol: Longint;
  var AStyle: TSortStyle);
begin
 if acol in [3,4] then AStyle:=ssNumeric else
    AStyle:=ssAlphabetic;
end;

procedure TDemo.AdvStringGrid1GetAlignment(Sender: TObject; ARow,
  ACol: Longint; var AAlignment: TAlignment);
begin
 if acol in [3,4] then aAlignment:=taRightJustify;
end;

procedure TDemo.Button6Click(Sender: TObject);
begin
 if radiogroup1.itemindex=0 then
   advstringgrid1.sortdirection:=sdAscending
 else
   advstringgrid1.sortdirection:=sdDescending;
 advstringgrid1.sortcolumn:=1;
 advstringgrid1.QSort;
end;

procedure TDemo.Button7Click(Sender: TObject);
var
 pagepreview:tpagepreview;
begin
 advstringgrid1.printsettings.titletext:=edit2.text;
 if checkbox2.checked then
    advstringgrid1.printsettings.time:=ppTopLeft
 else
    advstringgrid1.printsettings.time:=ppNone;

 if checkbox2.checked then
    advstringgrid1.printsettings.date:=ppTopRight
 else
    advstringgrid1.printsettings.date:=ppNone;

 if checkbox3.checked then
    advstringgrid1.printsettings.pagenr:=ppBottomCenter
 else
    advstringgrid1.printsettings.pagenr:=ppNone;

 if checkbox4.checked then
    advstringgrid1.printsettings.borders:=pbSingle
 else
    advstringgrid1.printsettings.borders:=pbNoborder;

{
 advstringgrid1.print;
}

{
 advstringgrid1.printpreview(paintbox1.canvas);
}

 pagepreview:=tpagepreview.create(self,advstringgrid1);
 try
  pagepreview.showmodal;
 finally
  pagepreview.free;
 end;

end;

procedure TDemo.Button8Click(Sender: TObject);
begin
 fontdialog1.font:=advstringgrid1.printsettings.font;
 if fontdialog1.execute then
   advstringgrid1.printsettings.font:=fontdialog1.font;
end;

procedure TDemo.AdvStringGrid1GetCellColor(Sender: TObject; ARow,
  ACol: Longint; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
 if (acol=1) and (arow>0) and (arow<advstringgrid1.rowcount-advstringgrid1.fixedfooters) and (not(gdSelected in AState) or (gdFocused in AState)) then
   begin
    abrush.color:=clYellow;
    afont.color:=clRed;
   end;
 if (arow=0) then
    begin
     afont.style:=[fsBold];
    end;
end;

procedure TDemo.InitGraphicGrid;
begin
  icon1:=ticon.create;
  icon1.handle:=loadicon(hinstance,'ICON_1');
  icon2:=ticon.create;
  icon2.handle:=loadicon(hinstance,'ICON_2');
  icon3:=ticon.create;
  icon3.handle:=loadicon(hinstance,'ICON_3');
  icon4:=ticon.create;
  icon4.handle:=loadicon(hinstance,'ICON_4');
  icon5:=ticon.create;
  icon5.handle:=loadicon(hinstance,'ICON_5');

  with advstringgrid2 do
   begin
    addicon(1,1,icon1,haCenter,vaAboveText);
    addicon(1,2,icon2,haCenter,vaAboveText);
    addicon(1,3,icon3,haCenter,vaAboveText);
    addicon(1,4,icon4,haCenter,vaAboveText);
    addicon(1,5,icon5,haCenter,vaAboveText);

    cells[1,0]:='Icons';
    cells[1,1]:='cpu';
    cells[1,2]:='trashcan';
    cells[1,3]:='icon';
    cells[1,4]:='floppy';
    cells[1,5]:='audio';


    addimageidx(2,1,0,habeforetext,vaCenter);
    addimageidx(2,2,1,haBeforeText,vaCenter);
    addimageidx(2,3,2,haBeforeText,vaCenter);
    addimageidx(2,4,3,haBeforeText,vaCenter);
    addimageidx(2,5,4,haBeforeText,vaCenter);

    cells[2,0]:='Imagelist';
    cells[2,1]:='mail';
    cells[2,2]:='note';
    cells[2,3]:='cancel';
    cells[2,4]:='home';
    cells[2,5]:='web';


    bitmap1:=tbitmap.create;
    bitmap1.handle:=loadbitmap(hinstance,'BITMAP_1');
    bitmap2:=tbitmap.create;
    bitmap2.handle:=loadbitmap(hinstance,'BITMAP_2');
    bitmap3:=tbitmap.create;
    bitmap3.handle:=loadbitmap(hinstance,'BITMAP_3');
    bitmap4:=tbitmap.create;
    bitmap4.handle:=loadbitmap(hinstance,'BITMAP_4');
    bitmap5:=tbitmap.create;
    bitmap5.handle:=loadbitmap(hinstance,'BITMAP_5');

    addbitmap(3,1,bitmap1,false,haright,vabottom);
    addbitmap(3,2,bitmap2,false,haright,vabottom);
    addbitmap(3,3,bitmap3,false,haright,vabottom);
    addbitmap(3,4,bitmap4,false,haright,vabottom);
    addbitmap(3,5,bitmap5,false,haright,vabottom);

    cells[3,0]:='Bitmaps';

    autonumbercol(0);

   end;

end;

procedure TDemo.FormCreate(Sender: TObject);
var
 stream:tresourcestream;
 i:integer;
begin
 advstringgrid1.Clear;
 advstringgrid1.loadfromfile('test.txt');

 {
  bitmap1:=tbitmap.create;
  bitmap1.loadfromfile('image1.bmp');
  advstringgrid1.addbitmap(1,1,bitmap1,haBeforeText,vaTop);
  advstringgrid1.addbitmap(2,0,bitmap1,haBeforeText,vaTop);

  bitmap2:=tbitmap.create;
  bitmap2.loadfromfile('image2.bmp');
  advstringgrid1.addbitmap(1,2,bitmap2,haBeforeText,vaTop);
 }

 {
  icon1:=ticon.create;
  icon1.loadfromfile('d:\internet\misc\icons\trashcan.ico');
  advstringgrid1.addicon(3,1,icon1,haBeforeText,vaTop);

  icon2:=ticon.create;
  icon2.loadfromfile('d:\internet\misc\icons\cpu.ico');
  advstringgrid1.addicon(3,2,icon2,haBeforeText,vaTop);
  }
  initgraphicGrid;
end;

procedure TDemo.AdvStringGrid1GridHint(Sender: TObject; Arow,
  Acol: Longint; var hintstr: string);
begin
 if acol=1 then hintstr:='Name of car company';
 if acol=2 then hintstr:='Car model';
 if acol=3 then hintstr:='# of cylinders';
 if acol=4 then hintstr:='Year of introduction';
end;

procedure TDemo.Button4Click(Sender: TObject);
begin
 advstringgrid1.savetoXLS('test.xls');
end;

procedure TDemo.Loadfromfile1Click(Sender: TObject);
begin
 advstringgrid1.Clear;
 advstringgrid1.loadfromfile('test.txt');
end;

procedure TDemo.Savetofile1Click(Sender: TObject);
begin
advstringgrid1.savetofile('test.txt');
end;

procedure TDemo.SavetoHTML1Click(Sender: TObject);
begin
 advstringgrid1.Savetohtml('test.htm');
end;

procedure TDemo.SavetoCSV1Click(Sender: TObject);
begin
 advstringgrid1.Savetocsv('test.csv');
end;

procedure TDemo.LoadfromCSV1Click(Sender: TObject);
begin
 advstringgrid1.loadfromcsv('sample.csv');
end;


procedure TDemo.AdvStringGrid1AutoInsertRow(Sender: TObject;
  ARow: Longint);
begin
 advstringgrid1.autonumbercol(0);
end;

procedure TDemo.AdvStringGrid1AutoDeleteRow(Sender: TObject;
  aRow: Longint);
begin
 advstringgrid1.autonumbercol(0);
end;

procedure TDemo.AdvStringGrid1ClickSort(Sender: TObject; aCol: Longint);
begin
 if not advstringgrid1.sortfixedcols then
 advstringgrid1.autonumbercol(0);
end;

procedure TDemo.CopytoExcel1Click(Sender: TObject);
begin
 Advstringgrid1.savetoxls('test.xls');
end;

procedure TDemo.SaveasXLS1Click(Sender: TObject);
begin
 advstringgrid1.savetoxls('test.xls');
end;

procedure TDemo.Copytoclipboard2Click(Sender: TObject);
begin
 advstringgrid1.copytoclipboard;
end;

procedure TDemo.Copyselectiontoclipboard1Click(Sender: TObject);
begin
 advstringgrid1.copyselectiontoclipboard;
end;

procedure TDemo.Pastefromclipboard2Click(Sender: TObject);
begin
 advstringgrid1.pasteselectionfromclipboard;
end;

procedure TDemo.Pastefromclipboard1Click(Sender: TObject);
begin
 advstringgrid1.pastefromclipboard;
end;

procedure TDemo.Print2Click(Sender: TObject);
begin
 advstringgrid1.printsettings.titletext:=edit2.text;
 
 if checkbox2.checked then
    advstringgrid1.printsettings.time:=ppTopLeft
 else
    advstringgrid1.printsettings.time:=ppNone;

 if checkbox2.checked then
    advstringgrid1.printsettings.date:=ppTopRight
 else
    advstringgrid1.printsettings.date:=ppNone;

 if checkbox3.checked then
    advstringgrid1.printsettings.pagenr:=ppBottomCenter
 else
    advstringgrid1.printsettings.pagenr:=ppNone;

 if checkbox4.checked then
    advstringgrid1.printsettings.borders:=pbSingle
 else
    advstringgrid1.printsettings.borders:=pbNoborder;

 advstringgrid1.print;
end;

procedure TDemo.Printpreview1Click(Sender: TObject);
var
 pagepreview:tpagepreview;
begin
 advstringgrid1.printsettings.titletext:=edit2.text;
 if checkbox2.checked then
    advstringgrid1.printsettings.time:=ppTopLeft
 else
    advstringgrid1.printsettings.time:=ppNone;

 if checkbox1.checked then
    advstringgrid1.printsettings.date:=ppTopRight
 else
    advstringgrid1.printsettings.date:=ppNone;

 if checkbox3.checked then
    advstringgrid1.printsettings.pagenr:=ppBottomCenter
 else
    advstringgrid1.printsettings.pagenr:=ppNone;

 if checkbox4.checked then
    advstringgrid1.printsettings.borders:=pbSingle
 else
    advstringgrid1.printsettings.borders:=pbNoborder;

 pagepreview:=tpagepreview.create(self,advstringgrid1);
 try
  pagepreview.showmodal;
 finally
  pagepreview.free;
 end;
end;

procedure TDemo.About1Click(Sender: TObject);
var
 About:tAbout;
begin
 About:=tAbout.Create(self);
 try
  About.showmodal;
 finally
  about.free;
 end;
end;

procedure TDemo.Setselection1Click(Sender: TObject);
var
 gridrect:tgridrect;
begin
 gridrect.left:=1;
 gridrect.top:=5;
 gridrect.right:=advstringgrid1.colcount-1;
 gridrect.bottom:=advstringgrid1.rowcount-1;
 advstringgrid1.printrect(gridrect);
end;

procedure TDemo.fixedsortClick(Sender: TObject);
begin
 advstringgrid1.sortfixedcols:=fixedsort.checked;
end;



procedure TDemo.LoadfromXLS1Click(Sender: TObject);
begin
 advstringgrid1.loadfromxls('test.xls');
end;

procedure TDemo.AdvStringGrid1PrintPage(Sender: TObject; Canvas: TCanvas;
  pagenr, pagexsize, pageysize: Integer);
var
 savefont:tfont;
begin


 with canvas do
  begin
   moveto(0,-advstringgrid1.printsettings.headersize+5);
   lineto(pagexsize,-advstringgrid1.printsettings.headersize+5);

   savefont:=tfont.create;
   savefont.assign(font);

   font.name:='Arial';
   font.style:=[fsBold];
   font.height:=advstringgrid1.mapfontheight(14);
   font.color:=clRed;

   textout(0,0,'Your company name can go here using custom drawing');

   font.assign(savefont);
   savefont.free;

  end;

end;

procedure TDemo.Column11Click(Sender: TObject);
var
 acol:longint;
begin
  acol:=(sender as tmenuitem).tag;
  with advstringgrid1 do
   begin
    if ishiddencolumn(acol) then unhidecolumn(acol)
    else hidecolumn(acol);
    (sender as tmenuitem).checked:=ishiddencolumn(acol);
   end;
end;

procedure TDemo.Findfirst1Click(Sender: TObject);
var
 res:tpoint;
 finddlg:tfinddlg;
 findparams:tfindparams;

begin
 finddlg:=tfinddlg.create(self);
 try
  if (finddlg.showmodal=mrOk) then
   begin
    findparams:=[];
    if finddlg.chkcase.checked then findparams:=findparams + [fnMatchCase];
    if finddlg.chkfull.checked then findparams:=findparams + [fnMatchFull];
    if finddlg.chkregular.checked then findparams:=findparams + [fnMatchRegular];
    res:=advstringgrid1.findfirst(finddlg.findtext.text,findparams);
    if res.x>=0 then
     begin
      advstringgrid1.col:=res.x;
      advstringgrid1.row:=res.y;
     end
    else
      messagedlg('Text not found',mtinformation,[mbOK],0);
   end;
 finally
  finddlg.free;
 end;

{
 res:=advstringgrid1.findfirst(InputBox('Search','String','*'),[fnMatchFull,fnMatchCase]);
 if res.x>0 then
   begin
    advstringgrid1.col:=res.x;
    advstringgrid1.row:=res.y;
   end;
 }
end;

procedure TDemo.Findnext1Click(Sender: TObject);
var
 res:tpoint;
begin
 res:=advstringgrid1.findnext;
 if (res.x>=0) and (res.y>=0) then
   begin
    advstringgrid1.col:=res.x;
    advstringgrid1.row:=res.y;
   end
 else
  messagedlg('Text not found',mtinformation,[mbOK],0);
end;

procedure TDemo.multilineClick(Sender: TObject);
var
 i:integer;
begin

 if multiline.checked then
   advstringgrid1.defaultrowheight:=28
 else
   advstringgrid1.defaultrowheight:=14;

 advstringgrid1.multilinecells:=multiline.checked;

 {
 if multiline.checked then
  begin
   for i:=1 to advstringgrid1.rowcount-1 do
    begin
     advstringgrid1.cells[1,i]:=advstringgrid1.cells[1,i]+#13#10+'line 2';
    end;
  end;
 }
end;

procedure TDemo.AdvStringGrid1CanEditCell(Sender: TObject; Arow,
  Acol: Integer; var canedit: Boolean);
begin
 canedit:=(acol<>3) or (colro.checked=false);
end;

procedure TDemo.AdvStringGrid1CellValidate(Sender: TObject; Col,
  Row: Integer; var Value: String; var Valid: Boolean);
var
 code,i:integer;
begin
 if (col>=3) then
  begin
    val(value,i,code);
    valid:=(code=0) and (i>0);
    if not valid then messagedlg('Validation example'#13#10'Input should be a number > 0',mtinformation,[mbok],0);
  end;

end;

procedure TDemo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 icon1.free;
 icon2.free;
 icon3.free;
 icon4.free;
 icon5.free;

 bitmap1.free;
 bitmap2.free;
 bitmap3.free;
 bitmap4.free;
 bitmap5.free;
end;

procedure TDemo.AdvStringGrid2GetAlignment(Sender: TObject; ARow,
  ACol: Integer; var AAlignment: TAlignment);
begin
 if acol<>2 then Aalignment:=taCenter;
end;


end.
